#include <windows.h>
#include <ddraw.h>
#include "ddutil.h"

#define  WindowTitle      "DirectDraw-Tutorial"
#define  WindowClassName  "DDWinClass"

LPDIRECTDRAW7			lpDirectDraw;	// DirectDraw-Objekt
HRESULT					ddrval;
LPDIRECTDRAWSURFACE7	lpddsPrimary;
LPDIRECTDRAWSURFACE7	lpddsBack;
LPDIRECTDRAWSURFACE7	lpddsBitmap;
DDSURFACEDESC2			ddsd;
DDSCAPS2				ddscaps; 
DDBLTFX					ddbltfx;
RECT					fill_area;
RECT					rectbitmap; 
bool					running;



LONG FAR WINAPI WndProc (HWND , UINT , UINT , LONG) ;

int WINAPI WinMain (HINSTANCE hInstance , HINSTANCE hPrevInstance , 
					LPSTR lpCmdLine , int nCmdShow)
{
	MSG      msg      ;  
	HWND     hwnd     ;   
	WNDCLASS wndclass ; 
	if (!hPrevInstance)
    {
		wndclass.style         = CS_HREDRAW | CS_VREDRAW  ;
		wndclass.lpfnWndProc   = WndProc ;
		wndclass.cbClsExtra    = 0 ;
		wndclass.cbWndExtra    = 0 ;
		wndclass.hInstance     = hInstance   ;
		wndclass.hIcon         = LoadIcon (NULL , IDI_APPLICATION) ;
		wndclass.hCursor       = LoadCursor (NULL , IDC_ARROW)  ; 
		wndclass.hbrBackground = (HBRUSH)GetStockObject (LTGRAY_BRUSH)  ;
		wndclass.lpszMenuName  = NULL              ;
		wndclass.lpszClassName = WindowClassName ; 
		RegisterClass (&wndclass) ;    
	}
	hwnd = CreateWindow (WindowClassName , 
                         WindowTitle , 
                         WS_OVERLAPPEDWINDOW , 
			             CW_USEDEFAULT , 
						 CW_USEDEFAULT ,
                         CW_USEDEFAULT , 
                         CW_USEDEFAULT ,     
                         NULL , NULL , 
                         hInstance , NULL) ;     
	ShowWindow   (hwnd , nCmdShow) ;  
	UpdateWindow (hwnd) ;

	ddrval = DirectDrawCreateEx(NULL, (VOID**)&lpDirectDraw, IID_IDirectDraw7, NULL); 
	if (ddrval != DD_OK)
	{
		return (0);
	}    

	ddrval = lpDirectDraw->SetCooperativeLevel (hwnd, DDSCL_EXCLUSIVE |	DDSCL_FULLSCREEN);
	if (ddrval != DD_OK)
	{
		lpDirectDraw->Release();
		lpDirectDraw = NULL;
		return (0);
	}

	ddrval = lpDirectDraw->SetDisplayMode (640, 480, 8, 0, 0);
	if (ddrval != DD_OK)
	{
		lpDirectDraw->Release();
		lpDirectDraw = NULL;
		return (0);
	}

	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1; 
	ddrval = lpDirectDraw->CreateSurface (&ddsd, &lpddsPrimary, NULL);
	if (ddrval != DD_OK)
	{
		lpDirectDraw->Release();
		lpDirectDraw = NULL;
		return (0);
	}
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	lpddsPrimary->GetAttachedSurface(&ddscaps, &lpddsBack); 

	ddbltfx.dwSize = sizeof(DDBLTFX);
	ddbltfx.dwFillColor = RGB(0, 0, 0); 
	SetRect(&fill_area, 0, 0, 640, 480);

	lpddsBitmap = DDLoadBitmap(lpDirectDraw, "Test.bmp", 200, 150);
	SetRect(&rectbitmap, 220, 165, 420, 315); 

	running=true;

	while(running)
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{ 
			if (msg.message == WM_QUIT) break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
			lpddsBack->Blt(&fill_area, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx); 
			lpddsBack->Blt(&rectbitmap, lpddsBitmap, NULL, DDBLT_WAIT, NULL);
			while(lpddsPrimary->Flip(NULL, DDFLIP_WAIT) != DD_OK); 
		}
	} 

	if (lpddsBack != NULL)
	{
		lpddsBack->Release();
		lpddsBack = NULL;
	} 


	if (lpddsPrimary != NULL)
	{
		lpddsPrimary->Release();
		lpddsPrimary = NULL;
	}

	if (lpDirectDraw != NULL)
	{
		lpDirectDraw->Release();
		lpDirectDraw = NULL;
	}

	return msg.wParam ;
}


LONG FAR WINAPI WndProc (HWND hwnd , UINT message , 
                         UINT wParam , LONG lParam) 
{ 
	switch (message)
	{
		case WM_KEYDOWN:
		{
			switch (wParam)
			{
			case VK_ESCAPE:
				running=false;
				return 0;
			} break;
		}
		case WM_DESTROY:
		{
			PostQuitMessage (0) ; 
			return 0 ;
		} break;
	} // switch (message)
	return DefWindowProc (hwnd , message , wParam , lParam) ;
} // WndProc 

